class swinir(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  precision : int
  img_range : float
  mean : Tensor
  upscale : int
  window_size : int
  num_layers : int
  embed_dim : int
  ape : bool
  patch_norm : bool
  num_features : int
  mlp_ratio : float
  patches_resolution : List[int]
  conv_first : __torch__.torch.nn.modules.conv.___torch_mangle_8.Conv2d
  patch_embed : __torch__.model.swinir.PatchEmbed
  patch_unembed : __torch__.model.swinir.PatchUnEmbed
  pos_drop : __torch__.torch.nn.modules.dropout.Dropout
  layers : __torch__.torch.nn.modules.container.___torch_mangle_20.ModuleList
  norm : __torch__.torch.nn.modules.normalization.LayerNorm
  conv_after_body : __torch__.torch.nn.modules.conv.___torch_mangle_15.Conv2d
  uplayers : __torch__.torch.nn.modules.container.___torch_mangle_21.ModuleList
  conv_before_upsample : __torch__.torch.nn.modules.container.___torch_mangle_23.Sequential
  upsample : __torch__.model.swinir.Upsample
  conv_last : __torch__.torch.nn.modules.conv.___torch_mangle_24.Conv2d
  def forward(self: __torch__.model.swinir.swinir,
    x: Tensor) -> Tensor:
    _0 = __torch__.torch.nn.functional.___torch_mangle_25.interpolate
    precision = self.precision
    if torch.eq(precision, 5):
      x0 = torch.to(x, 5)
    else:
      x0 = x
    H, W, = torch.slice(torch.size(x0), 2)
    x1 = (self).check_image_size(x0, )
    mean = self.mean
    self.mean = torch.type_as(mean, x1)
    mean0 = self.mean
    _1 = torch.sub(x1, mean0)
    img_range = self.img_range
    x2 = torch.mul(_1, img_range)
    conv_first = self.conv_first
    x3 = (conv_first).forward(x2, )
    conv_after_body = self.conv_after_body
    _2 = (conv_after_body).forward((self).forward_features(x3, ), )
    x4 = torch.add(_2, x3)
    conv_before_upsample = self.conv_before_upsample
    x5 = (conv_before_upsample).forward(x4, )
    upscale = self.upscale
    if torch.eq(upscale, 11):
      upscale0 = self.upscale
      _3 = torch.mul(H, upscale0)
      upscale1 = self.upscale
      x7 = _0(x5, [_3, torch.mul(W, upscale1)], None, "bilinear", None, None, )
      x6 = x7
    else:
      upsample = self.upsample
      x6 = (upsample).forward(x5, )
    conv_last = self.conv_last
    x8 = (conv_last).forward(x6, )
    img_range0 = self.img_range
    _4 = torch.div(x8, img_range0)
    mean1 = self.mean
    x9 = torch.add(_4, mean1)
    _5 = torch.slice(torch.slice(x9), 1)
    upscale2 = self.upscale
    _6 = torch.slice(_5, 2, None, torch.mul(H, upscale2))
    upscale3 = self.upscale
    _7 = torch.slice(_6, 3, None, torch.mul(W, upscale3))
    return _7
  def check_image_size(self: __torch__.model.swinir.swinir,
    x: Tensor) -> Tensor:
    _8, _9, h, w, = torch.size(x)
    window_size = self.window_size
    window_size0 = self.window_size
    _10 = torch.sub(window_size, torch.remainder(h, window_size0))
    window_size1 = self.window_size
    mod_pad_h = torch.remainder(_10, window_size1)
    window_size2 = self.window_size
    window_size3 = self.window_size
    _11 = torch.sub(window_size2, torch.remainder(w, window_size3))
    window_size4 = self.window_size
    mod_pad_w = torch.remainder(_11, window_size4)
    x10 = __torch__.torch.nn.functional._pad(x, [0, mod_pad_w, 0, mod_pad_h], "reflect", 0., )
    return x10
  def forward_features(self: __torch__.model.swinir.swinir,
    x: Tensor) -> Tensor:
    x_size = ((torch.size(x))[2], (torch.size(x))[3])
    patch_embed = self.patch_embed
    x11 = (patch_embed).forward(x, )
    pos_drop = self.pos_drop
    x12 = (pos_drop).forward(x11, )
    layers = self.layers
    _0 = getattr(layers, "0")
    _1 = getattr(layers, "1")
    _2 = getattr(layers, "2")
    x13 = (_0).forward(x12, x_size, )
    x14 = (_1).forward(x13, x_size, )
    x15 = (_2).forward(x14, x_size, )
    norm = self.norm
    x16 = (norm).forward(x15, )
    patch_unembed = self.patch_unembed
    x17 = (patch_unembed).forward(x16, x_size, )
    return x17
class PatchEmbed(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  img_size : Tuple[int, int]
  patch_size : Tuple[int, int]
  patches_resolution : List[int]
  num_patches : int
  in_chans : int
  embed_dim : int
  norm : __torch__.torch.nn.modules.normalization.LayerNorm
  def forward(self: __torch__.model.swinir.PatchEmbed,
    x: Tensor) -> Tensor:
    x18 = torch.transpose(torch.flatten(x, 2), 1, 2)
    norm = self.norm
    return (norm).forward(x18, )
class PatchUnEmbed(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  img_size : Tuple[int, int]
  patch_size : Tuple[int, int]
  patches_resolution : List[int]
  num_patches : int
  in_chans : int
  embed_dim : int
  def forward(self: __torch__.model.swinir.PatchUnEmbed,
    x: Tensor,
    x_size: Tuple[int, int]) -> Tensor:
    B, HW, C, = torch.size(x)
    _12 = torch.transpose(x, 1, 2)
    embed_dim = self.embed_dim
    _13 = [B, embed_dim, (x_size)[0], (x_size)[1]]
    return torch.view(_12, _13)
class RSTB(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  dim : int
  input_resolution : Tuple[int, int]
  pruned : bool
  residual_group : __torch__.model.swinir.BasicLayer
  conv : __torch__.torch.nn.modules.conv.___torch_mangle_15.Conv2d
  patch_embed : __torch__.model.swinir.___torch_mangle_16.PatchEmbed
  patch_unembed : __torch__.model.swinir.PatchUnEmbed
  def forward(self: __torch__.model.swinir.RSTB,
    x: Tensor,
    x_size: Tuple[int, int]) -> Tensor:
    pruned = self.pruned
    if pruned:
      _14 = x
    else:
      residual_group = self.residual_group
      y = (residual_group).forward(x, x_size, )
      patch_unembed = self.patch_unembed
      y1 = (patch_unembed).forward(y, x_size, )
      patch_embed = self.patch_embed
      conv = self.conv
      y2 = (patch_embed).forward((conv).forward(y1, ), )
      _14 = torch.add(y2, x)
    return _14
class BasicLayer(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  dim : int
  input_resolution : Tuple[int, int]
  depth : int
  use_checkpoint : bool
  downsample : NoneType
  blocks : __torch__.torch.nn.modules.container.___torch_mangle_14.ModuleList
  def forward(self: __torch__.model.swinir.BasicLayer,
    x: Tensor,
    x_size: Tuple[int, int]) -> Tensor:
    blocks = self.blocks
    _0 = getattr(blocks, "0")
    _1 = getattr(blocks, "1")
    _2 = getattr(blocks, "2")
    _3 = getattr(blocks, "3")
    _4 = getattr(blocks, "4")
    _5 = getattr(blocks, "5")
    x19 = (_0).forward(x, x_size, )
    x20 = (_1).forward(x19, x_size, )
    x21 = (_2).forward(x20, x_size, )
    x22 = (_3).forward(x21, x_size, )
    x23 = (_4).forward(x22, x_size, )
    return (_5).forward(x23, x_size, )
class SwinTransformerBlock(Module):
  __parameters__ = []
  __buffers__ = ["attn_mask", ]
  attn_mask : NoneType
  training : bool
  _is_full_backward_hook : Optional[bool]
  dim : int
  input_resolution : Tuple[int, int]
  num_heads : int
  window_size : int
  shift_size : int
  mlp_ratio : float
  norm1 : __torch__.torch.nn.modules.normalization.LayerNorm
  attn : __torch__.model.swinir.WindowAttention
  drop_path : __torch__.torch.nn.modules.linear.Identity
  norm2 : __torch__.torch.nn.modules.normalization.LayerNorm
  mlp : __torch__.model.swinir.Mlp
  def forward(self: __torch__.model.swinir.SwinTransformerBlock,
    x: Tensor,
    x_size: Tuple[int, int]) -> Tensor:
    _15 = __torch__.model.swinir.window_partition
    _16 = __torch__.model.swinir.window_reverse
    H = (x_size)[0]
    W = (x_size)[1]
    B, L, C, = torch.size(x)
    norm1 = self.norm1
    x24 = (norm1).forward(x, )
    x25 = torch.view(x24, [B, H, W, C])
    shift_size = self.shift_size
    if torch.gt(shift_size, 0):
      shift_size0 = self.shift_size
      _17 = torch.neg(shift_size0)
      shift_size1 = self.shift_size
      shifted_x0 = torch.roll(x25, [_17, torch.neg(shift_size1)], [1, 2])
      shifted_x = shifted_x0
    else:
      shifted_x = x25
    window_size = self.window_size
    x_windows = _15(shifted_x, window_size, )
    window_size5 = self.window_size
    window_size6 = self.window_size
    _18 = torch.mul(window_size5, window_size6)
    x_windows0 = torch.view(x_windows, [-1, _18, C])
    input_resolution = self.input_resolution
    _19, _20, = input_resolution
    _21 = [_19, _20]
    _22, _23, = x_size
    if torch.eq(_21, [_22, _23]):
      attn = self.attn
      attn_mask = self.attn_mask
      attn_windows0 = (attn).forward(x_windows0, attn_mask, )
      attn_windows = attn_windows0
    else:
      attn0 = self.attn
      _24 = torch.to((self).calculate_mask(x_size, ), ops.prim.device(x25))
      attn_windows1 = (attn0).forward(x_windows0, _24, )
      attn_windows = attn_windows1
    window_size7 = self.window_size
    window_size8 = self.window_size
    attn_windows2 = torch.view(attn_windows, [-1, window_size7, window_size8, C])
    window_size9 = self.window_size
    shifted_x1 = _16(attn_windows2, window_size9, H, W, )
    shift_size2 = self.shift_size
    if torch.gt(shift_size2, 0):
      shift_size3 = self.shift_size
      shift_size4 = self.shift_size
      x27 = torch.roll(shifted_x1, [shift_size3, shift_size4], [1, 2])
      x26 = x27
    else:
      x26 = shifted_x1
    x28 = torch.view(x26, [B, torch.mul(H, W), C])
    drop_path = self.drop_path
    x29 = torch.add(x, (drop_path).forward(x28, ))
    drop_path0 = self.drop_path
    mlp = self.mlp
    norm2 = self.norm2
    _25 = (mlp).forward((norm2).forward(x29, ), )
    x30 = torch.add(x29, (drop_path0).forward(_25, ))
    return x30
  def calculate_mask(self: __torch__.model.swinir.SwinTransformerBlock,
    x_size: Tuple[int, int]) -> Tensor:
    _26 = __torch__.model.swinir.window_partition
    H = (x_size)[0]
    W = (x_size)[1]
    img_mask = torch.zeros([1, H, W, 1])
    window_size = self.window_size
    _27 = torch.neg(window_size)
    window_size10 = self.window_size
    _28 = torch.neg(window_size10)
    shift_size = self.shift_size
    _29 = torch.neg(shift_size)
    shift_size5 = self.shift_size
    _30 = torch.neg(shift_size5)
    window_size11 = self.window_size
    _31 = torch.neg(window_size11)
    window_size12 = self.window_size
    _32 = torch.neg(window_size12)
    shift_size6 = self.shift_size
    _33 = torch.neg(shift_size6)
    shift_size7 = self.shift_size
    _34 = torch.neg(shift_size7)
    _35 = torch.slice(torch.slice(img_mask), 1, 0, _27)
    _36 = torch.slice(torch.slice(_35, 2, 0, _31), 3)
    _37 = torch.tensor(0, dtype=ops.prim.dtype(_36), device=ops.prim.device(_36))
    _38 = torch.copy_(_36, _37)
    _39 = torch.slice(torch.slice(img_mask), 1, 0, _27)
    _40 = torch.slice(torch.slice(_39, 2, _32, _33), 3)
    _41 = torch.tensor(1, dtype=ops.prim.dtype(_40), device=ops.prim.device(_40))
    _42 = torch.copy_(_40, _41)
    _43 = torch.slice(torch.slice(img_mask), 1, 0, _27)
    _44 = torch.slice(torch.slice(_43, 2, _34), 3)
    _45 = torch.tensor(2, dtype=ops.prim.dtype(_44), device=ops.prim.device(_44))
    _46 = torch.copy_(_44, _45)
    _47 = torch.slice(torch.slice(img_mask), 1, _28, _29)
    _48 = torch.slice(torch.slice(_47, 2, 0, _31), 3)
    _49 = torch.tensor(3, dtype=ops.prim.dtype(_48), device=ops.prim.device(_48))
    _50 = torch.copy_(_48, _49)
    _51 = torch.slice(torch.slice(img_mask), 1, _28, _29)
    _52 = torch.slice(torch.slice(_51, 2, _32, _33), 3)
    _53 = torch.tensor(4, dtype=ops.prim.dtype(_52), device=ops.prim.device(_52))
    _54 = torch.copy_(_52, _53)
    _55 = torch.slice(torch.slice(img_mask), 1, _28, _29)
    _56 = torch.slice(torch.slice(_55, 2, _34), 3)
    _57 = torch.tensor(5, dtype=ops.prim.dtype(_56), device=ops.prim.device(_56))
    _58 = torch.copy_(_56, _57)
    _59 = torch.slice(torch.slice(img_mask), 1, _30)
    _60 = torch.slice(torch.slice(_59, 2, 0, _31), 3)
    _61 = torch.tensor(6, dtype=ops.prim.dtype(_60), device=ops.prim.device(_60))
    _62 = torch.copy_(_60, _61)
    _63 = torch.slice(torch.slice(img_mask), 1, _30)
    _64 = torch.slice(torch.slice(_63, 2, _32, _33), 3)
    _65 = torch.tensor(7, dtype=ops.prim.dtype(_64), device=ops.prim.device(_64))
    _66 = torch.copy_(_64, _65)
    _67 = torch.slice(torch.slice(img_mask), 1, _30)
    _68 = torch.slice(torch.slice(_67, 2, _34), 3)
    _69 = torch.tensor(8, dtype=ops.prim.dtype(_68), device=ops.prim.device(_68))
    _70 = torch.copy_(_68, _69)
    window_size13 = self.window_size
    mask_windows = _26(img_mask, window_size13, )
    window_size14 = self.window_size
    window_size15 = self.window_size
    _71 = torch.mul(window_size14, window_size15)
    mask_windows0 = torch.view(mask_windows, [-1, _71])
    attn_mask = torch.sub(torch.unsqueeze(mask_windows0, 1), torch.unsqueeze(mask_windows0, 2))
    _72 = torch.masked_fill(attn_mask, torch.ne(attn_mask, 0), -100.)
    attn_mask0 = torch.masked_fill(_72, torch.eq(attn_mask, 0), 0.)
    mlp = self.mlp
    fc1 = mlp.fc1
    weight = fc1.weight
    _73 = torch.to(attn_mask0, ops.prim.dtype(weight))
    return _73
class WindowAttention(Module):
  __parameters__ = ["relative_position_bias_table", ]
  __buffers__ = ["relative_position_index", ]
  relative_position_bias_table : Tensor
  relative_position_index : Tensor
  training : bool
  _is_full_backward_hook : Optional[bool]
  dim : int
  window_size : Tuple[int, int]
  num_heads : int
  scale : float
  qkv : __torch__.torch.nn.modules.linear.Linear
  attn_drop : __torch__.torch.nn.modules.dropout.Dropout
  proj : __torch__.torch.nn.modules.linear.___torch_mangle_9.Linear
  proj_drop : __torch__.torch.nn.modules.dropout.Dropout
  softmax : __torch__.torch.nn.modules.activation.Softmax
  def forward(self: __torch__.model.swinir.WindowAttention,
    x: Tensor,
    mask: Optional[Tensor]) -> Tensor:
    B_, N, C, = torch.size(x)
    qkv = self.qkv
    _74 = (qkv).forward(x, )
    num_heads = self.num_heads
    num_heads0 = self.num_heads
    _75 = [B_, N, 3, num_heads, torch.floordiv(C, num_heads0)]
    qkv0 = torch.permute(torch.reshape(_74, _75), [2, 0, 3, 1, 4])
    q = torch.select(qkv0, 0, 0)
    k = torch.select(qkv0, 0, 1)
    v = torch.select(qkv0, 0, 2)
    scale = self.scale
    q0 = torch.mul(q, scale)
    attn = torch.matmul(q0, torch.transpose(k, -2, -1))
    relative_position_bias_table = self.relative_position_bias_table
    relative_position_index = self.relative_position_index
    _76 = torch.view(relative_position_index, [-1])
    _77 = annotate(List[Optional[Tensor]], [_76])
    _78 = torch.index(relative_position_bias_table, _77)
    window_size = self.window_size
    _79 = (window_size)[0]
    window_size16 = self.window_size
    _80 = torch.mul(_79, (window_size16)[1])
    window_size17 = self.window_size
    _81 = (window_size17)[0]
    window_size18 = self.window_size
    _82 = [_80, torch.mul(_81, (window_size18)[1]), -1]
    relative_position_bias = torch.view(_78, _82)
    _83 = torch.permute(relative_position_bias, [2, 0, 1])
    relative_position_bias0 = torch.contiguous(_83)
    _84 = torch.unsqueeze(relative_position_bias0, 0)
    attn1 = torch.add(attn, _84)
    if torch.__isnot__(mask, None):
      mask0 = unchecked_cast(Tensor, mask)
      nW = (torch.size(mask0))[0]
      _85 = torch.floordiv(B_, nW)
      num_heads1 = self.num_heads
      _86 = torch.view(attn1, [_85, nW, num_heads1, N, N])
      _87 = torch.unsqueeze(torch.unsqueeze(mask0, 1), 0)
      attn3 = torch.add(_86, _87)
      num_heads2 = self.num_heads
      attn4 = torch.view(attn3, [-1, num_heads2, N, N])
      softmax = self.softmax
      attn2 = (softmax).forward(attn4, )
    else:
      softmax0 = self.softmax
      attn2 = (softmax0).forward(attn1, )
    attn_drop = self.attn_drop
    attn5 = (attn_drop).forward(attn2, )
    _88 = torch.transpose(torch.matmul(attn5, v), 1, 2)
    x31 = torch.reshape(_88, [B_, N, C])
    proj = self.proj
    x32 = (proj).forward(x31, )
    proj_drop = self.proj_drop
    return (proj_drop).forward(x32, )
class Mlp(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  fc1 : __torch__.torch.nn.modules.linear.___torch_mangle_10.Linear
  act : __torch__.torch.nn.modules.activation.GELU
  fc2 : __torch__.torch.nn.modules.linear.___torch_mangle_11.Linear
  drop : __torch__.torch.nn.modules.dropout.Dropout
  def forward(self: __torch__.model.swinir.Mlp,
    x: Tensor) -> Tensor:
    fc1 = self.fc1
    x33 = (fc1).forward(x, )
    act = self.act
    x34 = (act).forward(x33, )
    drop = self.drop
    x35 = (drop).forward(x34, )
    fc2 = self.fc2
    x36 = (fc2).forward(x35, )
    drop0 = self.drop
    return (drop0).forward(x36, )
class Upsample(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : NoneType
  def forward(self: __torch__.model.swinir.Upsample,
    input: Tensor) -> Tensor:
    return input
  def __len__(self: __torch__.model.swinir.Upsample) -> int:
    return 0
def window_partition(x: Tensor,
    window_size: int) -> Tensor:
  B, H, W, C, = torch.size(x)
  _89 = [B, torch.floordiv(H, window_size), window_size, torch.floordiv(W, window_size), window_size, C]
  x37 = torch.view(x, _89)
  _90 = torch.permute(x37, [0, 1, 3, 2, 4, 5])
  windows = torch.view(torch.contiguous(_90), [-1, window_size, window_size, C])
  return windows
def window_reverse(windows: Tensor,
    window_size: int,
    H: int,
    W: int) -> Tensor:
  _91 = (torch.size(windows))[0]
  _92 = torch.div(torch.mul(H, W), window_size)
  _93 = torch.div(_91, torch.div(_92, window_size))
  B = int(_93)
  _94 = [B, torch.floordiv(H, window_size), torch.floordiv(W, window_size), window_size, window_size, -1]
  x = torch.view(windows, _94)
  _95 = torch.contiguous(torch.permute(x, [0, 1, 3, 2, 4, 5]))
  return torch.view(_95, [B, H, W, -1])
