class SwinTransformerBlock(Module):
  __parameters__ = []
  __buffers__ = ["attn_mask", ]
  attn_mask : NoneType
  training : bool
  _is_full_backward_hook : Optional[bool]
  dim : int
  input_resolution : Tuple[int, int]
  num_heads : int
  window_size : int
  shift_size : int
  mlp_ratio : float
  norm1 : __torch__.torch.nn.modules.normalization.LayerNorm
  attn : __torch__.model.swinir.WindowAttention
  drop_path : __torch__.timm.models.layers.drop.DropPath
  norm2 : __torch__.torch.nn.modules.normalization.LayerNorm
  mlp : __torch__.model.swinir.Mlp
  def forward(self: __torch__.model.swinir.___torch_mangle_13.SwinTransformerBlock,
    x: Tensor,
    x_size: Tuple[int, int]) -> Tensor:
    _0 = __torch__.model.swinir.window_partition
    _1 = __torch__.model.swinir.window_reverse
    H = (x_size)[0]
    W = (x_size)[1]
    B, L, C, = torch.size(x)
    norm1 = self.norm1
    x0 = (norm1).forward(x, )
    x1 = torch.view(x0, [B, H, W, C])
    shift_size = self.shift_size
    if torch.gt(shift_size, 0):
      shift_size0 = self.shift_size
      _2 = torch.neg(shift_size0)
      shift_size1 = self.shift_size
      shifted_x0 = torch.roll(x1, [_2, torch.neg(shift_size1)], [1, 2])
      shifted_x = shifted_x0
    else:
      shifted_x = x1
    window_size = self.window_size
    x_windows = _0(shifted_x, window_size, )
    window_size0 = self.window_size
    window_size1 = self.window_size
    _3 = torch.mul(window_size0, window_size1)
    x_windows0 = torch.view(x_windows, [-1, _3, C])
    input_resolution = self.input_resolution
    _4, _5, = input_resolution
    _6 = [_4, _5]
    _7, _8, = x_size
    if torch.eq(_6, [_7, _8]):
      attn = self.attn
      attn_mask = self.attn_mask
      attn_windows0 = (attn).forward(x_windows0, attn_mask, )
      attn_windows = attn_windows0
    else:
      attn0 = self.attn
      _9 = torch.to((self).calculate_mask(x_size, ), ops.prim.device(x1))
      attn_windows = (attn0).forward(x_windows0, _9, )
    window_size2 = self.window_size
    window_size3 = self.window_size
    attn_windows1 = torch.view(attn_windows, [-1, window_size2, window_size3, C])
    window_size4 = self.window_size
    shifted_x1 = _1(attn_windows1, window_size4, H, W, )
    shift_size2 = self.shift_size
    if torch.gt(shift_size2, 0):
      shift_size3 = self.shift_size
      shift_size4 = self.shift_size
      x3 = torch.roll(shifted_x1, [shift_size3, shift_size4], [1, 2])
      x2 = x3
    else:
      x2 = shifted_x1
    x4 = torch.view(x2, [B, torch.mul(H, W), C])
    drop_path = self.drop_path
    x5 = torch.add(x, (drop_path).forward(x4, ))
    drop_path0 = self.drop_path
    mlp = self.mlp
    norm2 = self.norm2
    _10 = (mlp).forward((norm2).forward(x5, ), )
    x6 = torch.add(x5, (drop_path0).forward(_10, ))
    return x6
  def calculate_mask(self: __torch__.model.swinir.___torch_mangle_13.SwinTransformerBlock,
    x_size: Tuple[int, int]) -> Tensor:
    _11 = __torch__.model.swinir.window_partition
    H = (x_size)[0]
    W = (x_size)[1]
    img_mask = torch.zeros([1, H, W, 1])
    window_size = self.window_size
    _12 = torch.neg(window_size)
    window_size5 = self.window_size
    _13 = torch.neg(window_size5)
    shift_size = self.shift_size
    _14 = torch.neg(shift_size)
    shift_size5 = self.shift_size
    _15 = torch.neg(shift_size5)
    window_size6 = self.window_size
    _16 = torch.neg(window_size6)
    window_size7 = self.window_size
    _17 = torch.neg(window_size7)
    shift_size6 = self.shift_size
    _18 = torch.neg(shift_size6)
    shift_size7 = self.shift_size
    _19 = torch.neg(shift_size7)
    _20 = torch.slice(torch.slice(img_mask), 1, 0, _12)
    _21 = torch.slice(torch.slice(_20, 2, 0, _16), 3)
    _22 = torch.tensor(0, dtype=ops.prim.dtype(_21), device=ops.prim.device(_21))
    _23 = torch.copy_(_21, _22)
    _24 = torch.slice(torch.slice(img_mask), 1, 0, _12)
    _25 = torch.slice(torch.slice(_24, 2, _17, _18), 3)
    _26 = torch.tensor(1, dtype=ops.prim.dtype(_25), device=ops.prim.device(_25))
    _27 = torch.copy_(_25, _26)
    _28 = torch.slice(torch.slice(img_mask), 1, 0, _12)
    _29 = torch.slice(torch.slice(_28, 2, _19), 3)
    _30 = torch.tensor(2, dtype=ops.prim.dtype(_29), device=ops.prim.device(_29))
    _31 = torch.copy_(_29, _30)
    _32 = torch.slice(torch.slice(img_mask), 1, _13, _14)
    _33 = torch.slice(torch.slice(_32, 2, 0, _16), 3)
    _34 = torch.tensor(3, dtype=ops.prim.dtype(_33), device=ops.prim.device(_33))
    _35 = torch.copy_(_33, _34)
    _36 = torch.slice(torch.slice(img_mask), 1, _13, _14)
    _37 = torch.slice(torch.slice(_36, 2, _17, _18), 3)
    _38 = torch.tensor(4, dtype=ops.prim.dtype(_37), device=ops.prim.device(_37))
    _39 = torch.copy_(_37, _38)
    _40 = torch.slice(torch.slice(img_mask), 1, _13, _14)
    _41 = torch.slice(torch.slice(_40, 2, _19), 3)
    _42 = torch.tensor(5, dtype=ops.prim.dtype(_41), device=ops.prim.device(_41))
    _43 = torch.copy_(_41, _42)
    _44 = torch.slice(torch.slice(img_mask), 1, _15)
    _45 = torch.slice(torch.slice(_44, 2, 0, _16), 3)
    _46 = torch.tensor(6, dtype=ops.prim.dtype(_45), device=ops.prim.device(_45))
    _47 = torch.copy_(_45, _46)
    _48 = torch.slice(torch.slice(img_mask), 1, _15)
    _49 = torch.slice(torch.slice(_48, 2, _17, _18), 3)
    _50 = torch.tensor(7, dtype=ops.prim.dtype(_49), device=ops.prim.device(_49))
    _51 = torch.copy_(_49, _50)
    _52 = torch.slice(torch.slice(img_mask), 1, _15)
    _53 = torch.slice(torch.slice(_52, 2, _19), 3)
    _54 = torch.tensor(8, dtype=ops.prim.dtype(_53), device=ops.prim.device(_53))
    _55 = torch.copy_(_53, _54)
    window_size8 = self.window_size
    mask_windows = _11(img_mask, window_size8, )
    window_size9 = self.window_size
    window_size10 = self.window_size
    _56 = torch.mul(window_size9, window_size10)
    mask_windows0 = torch.view(mask_windows, [-1, _56])
    attn_mask = torch.sub(torch.unsqueeze(mask_windows0, 1), torch.unsqueeze(mask_windows0, 2))
    _57 = torch.masked_fill(attn_mask, torch.ne(attn_mask, 0), -100.)
    attn_mask0 = torch.masked_fill(_57, torch.eq(attn_mask, 0), 0.)
    mlp = self.mlp
    fc1 = mlp.fc1
    weight = fc1.weight
    _58 = torch.to(attn_mask0, ops.prim.dtype(weight))
    return _58
